#include <math.h>
#include "CutterObject.h"

int trunc(double i)
{
	return (int)i;
}

double CutterObject::GetX(int i, int j, int k)
{
	return (i*(fBorderLength/(fBorderCount-1)));
}

double CutterObject::GetY(int i, int j, int k)
{
	return (j*(fBorderLength/(fBorderCount-1)));
}

double CutterObject::GetZ(int i, int j, int k)
{
	return (k*(fBorderLength/(fBorderCount-1)));
}

void CutterObject::SetMiniCubeDefaults()
{
	//задаем ребра
	fBorders[0].p1 = 0;		fBorders[0].p2 = 1;		fBorders[1].p1 = 1;		fBorders[1].p2 = 2;
	fBorders[2].p1 = 2;		fBorders[2].p2 = 3;		fBorders[3].p1 = 3;		fBorders[3].p2 = 0;
	fBorders[4].p1 = 4;		fBorders[4].p2 = 5;		fBorders[5].p1 = 5;		fBorders[5].p2 = 6;
	fBorders[6].p1 = 6;		fBorders[6].p2 = 7;		fBorders[7].p1 = 7;		fBorders[7].p2 = 4;
	fBorders[8].p1 = 0;		fBorders[8].p2 = 4;		fBorders[9].p1 = 1;		fBorders[9].p2 = 5;
	fBorders[10].p1 = 2;	fBorders[10].p2 = 6;	fBorders[11].p1 = 3;	fBorders[11].p2 = 7;

	//задаем грани
	fBoundaries[0][0] = 0;	fBoundaries[0][1] = 1;	fBoundaries[0][2] = 2;	fBoundaries[0][3] = 3;
	fBoundaries[1][0] = 4;	fBoundaries[1][1] = 5;	fBoundaries[1][2] = 6;	fBoundaries[1][3] = 7;
	fBoundaries[2][0] = 0;	fBoundaries[2][1] = 9;	fBoundaries[2][2] = 4;	fBoundaries[2][3] = 8;
	fBoundaries[3][0] = 1;	fBoundaries[3][1] = 10;	fBoundaries[3][2] = 5;	fBoundaries[3][3] = 9;
	fBoundaries[4][0] = 2;	fBoundaries[4][1] = 11;	fBoundaries[4][2] = 6;	fBoundaries[4][3] = 10;
	fBoundaries[5][0] = 3;	fBoundaries[5][1] = 11;	fBoundaries[5][2] = 7;	fBoundaries[5][3] = 8;

	//ставим линки
	fBorders[0].link[0] = 0;	fBorders[0].link[1] = 2;	fBorders[1].link[0] = 0;	fBorders[1].link[1] = 3;
	fBorders[2].link[0] = 0;	fBorders[2].link[1] = 4;	fBorders[3].link[0] = 0;	fBorders[3].link[1] = 5;
	fBorders[4].link[0] = 1;	fBorders[4].link[1] = 2;	fBorders[5].link[0] = 1;	fBorders[5].link[1] = 3;
	fBorders[6].link[0] = 1;	fBorders[6].link[1] = 4;	fBorders[7].link[0] = 1;	fBorders[7].link[1] = 5;
	fBorders[8].link[0] = 2;	fBorders[8].link[1] = 5;	fBorders[9].link[0] = 2;	fBorders[9].link[1] = 3;
	fBorders[10].link[0] = 3;	fBorders[10].link[1] = 4;	fBorders[11].link[0] = 4;	fBorders[11].link[1] = 5;
}

void CutterObject::SetMiniCube(int i, int j, int k)
{
	//задаем точки
	fMiniCube[0].fX = GetX(i,j,k);		fMiniCube[0].fY = GetY(i,j,k);
	fMiniCube[0].fZ = GetZ(i,j,k);		fMiniCube[0].fTemperature = fCube[i][j][k];
	fMiniCube[1].fX = GetX(i+1,j,k);	fMiniCube[1].fY = GetY(i+1,j,k);
	fMiniCube[1].fZ = GetZ(i+1,j,k);	fMiniCube[1].fTemperature = fCube[i+1][j][k];
	fMiniCube[2].fX = GetX(i+1,j+1,k);	fMiniCube[2].fY = GetY(i+1,j+1,k);
	fMiniCube[2].fZ = GetZ(i+1,j+1,k);	fMiniCube[2].fTemperature = fCube[i+1][j+1][k];
	fMiniCube[3].fX = GetX(i,j+1,k);	fMiniCube[3].fY = GetY(i,j+1,k);
	fMiniCube[3].fZ = GetZ(i,j+1,k);	fMiniCube[3].fTemperature = fCube[i][j+1][k];
	fMiniCube[4].fX = GetX(i,j,k+1);	fMiniCube[4].fY = GetY(i,j,k+1);
	fMiniCube[4].fZ = GetZ(i,j,k+1);	fMiniCube[4].fTemperature = fCube[i][j][k+1];
	fMiniCube[5].fX = GetX(i+1,j,k+1);	fMiniCube[5].fY = GetY(i+1,j,k+1);
	fMiniCube[5].fZ = GetZ(i+1,j,k+1);	fMiniCube[5].fTemperature = fCube[i+1][j][k+1];
	fMiniCube[6].fX = GetX(i+1,j+1,k+1);fMiniCube[6].fY = GetY(i+1,j+1,k+1);
	fMiniCube[6].fZ = GetZ(i+1,j+1,k+1);fMiniCube[6].fTemperature = fCube[i+1][j+1][k+1];
	fMiniCube[7].fX = GetX(i,j+1,k+1);	fMiniCube[7].fY = GetY(i,j+1,k+1);
	fMiniCube[7].fZ = GetZ(i,j+1,k+1);	fMiniCube[7].fTemperature = fCube[i][j+1][k+1];

	//сбрасываем пометки
	for (int m = 0; m < 12; m++) {
		fBorders[m].checked = false;
	}
}

void CutterObject::FindDegrees()
{
	fCosA = fNormalVectorY/sqrt(pow(fNormalVectorX,2) + pow(fNormalVectorY,2));
	fSinA = fNormalVectorX/sqrt(pow(fNormalVectorX,2) + pow(fNormalVectorY,2));
	fCosC = fNormalVectorZ/sqrt(
		pow(fNormalVectorX,2) +
		pow(fNormalVectorY,2) +
		pow(fNormalVectorZ,2)
	);
	fSinC = sqrt(pow(fNormalVectorX,2) + pow(fNormalVectorY,2))/sqrt(
		pow(fNormalVectorX,2) +
		pow(fNormalVectorY,2) +
		pow(fNormalVectorZ,2)
	);
}

double CutterObject::NewZ(double x, double y, double z)
{
	double new_y, new_z;

	x = x - fZeroPointX;
	y = y - fZeroPointY;
	z = z - fZeroPointZ;

	if ((fNormalVectorX == 0) &&
		(fNormalVectorY == 0) &&
		(fNormalVectorZ != 0)
	) {
		//вектора N и oZ параллельны
		new_z = z;
	} else {
		new_y = y*fCosA + x*fSinA;
		new_z = z*fCosC + new_y*fSinC;
	}

	return new_z;
}

void CutterObject::FindZ()
{
	zz0 = NewZ(GetX(0,0,0), GetY(0,0,0), GetZ(0,0,0));
	zz1 = NewZ(GetX(1,0,0), GetY(1,0,0), GetZ(1,0,0)) - zz0;
	zz2 = NewZ(GetX(0,1,0), GetY(0,1,0), GetZ(0,1,0)) - zz0;
	zz3 = NewZ(GetX(0,0,1), GetY(0,0,1), GetZ(0,0,1)) - zz0;
}

Dot CutterObject::FindNewDot(int rb)
{
	double koef; //коеффициент отличия
	double zzz1,zzz2;
	Dot newdot, p1, p2;

	if ((NewZ(fMiniCube[fBorders[rb].p1].fX, fMiniCube[fBorders[rb].p1].fY, fMiniCube[fBorders[rb].p1].fZ)) <
	(NewZ(fMiniCube[fBorders[rb].p2].fX, fMiniCube[fBorders[rb].p2].fY, fMiniCube[fBorders[rb].p2].fZ)))
	{
		p1 = fMiniCube[fBorders[rb].p1];
		p2 = fMiniCube[fBorders[rb].p2];
	} else {
		p1 = fMiniCube[fBorders[rb].p2];
		p2 = fMiniCube[fBorders[rb].p1];
	}

	zzz1 = NewZ(p1.fX, p1.fY, p1.fZ);
	zzz2 = NewZ(p2.fX, p2.fY, p2.fZ);

	if (zzz1 != 0) {
		koef = (-zzz1)/(zzz2-zzz1);

		newdot.fX = p1.fX + (p2.fX - p1.fX)*koef;
		newdot.fY = p1.fY + (p2.fY - p1.fY)*koef;
		newdot.fZ = p1.fZ + (p2.fZ - p1.fZ)*koef;
		newdot.fTemperature =
			(GLubyte)(p1.fTemperature +
			(p2.fTemperature - p1.fTemperature)*koef);
	} else {
		newdot = p1;
	}

	return newdot;
}

bool CutterObject::IsCrossed(int i)
{
	if (((fNormalVectorX == 0) && (fNormalVectorY == 0)) ||
		((fNormalVectorX == 0) && (fNormalVectorZ == 0)) ||
		((fNormalVectorY == 0) && (fNormalVectorZ == 0))
	) {
		if (((NewZ(fMiniCube[fBorders[i].p1].fX, fMiniCube[fBorders[i].p1].fY, fMiniCube[fBorders[i].p1].fZ) >= 0.000001) &&
			(NewZ(fMiniCube[fBorders[i].p2].fX, fMiniCube[fBorders[i].p2].fY, fMiniCube[fBorders[i].p2].fZ) <= 0.000001)) ||
			((NewZ(fMiniCube[fBorders[i].p1].fX, fMiniCube[fBorders[i].p1].fY, fMiniCube[fBorders[i].p1].fZ) <= 0.000001) &&
			(NewZ(fMiniCube[fBorders[i].p2].fX, fMiniCube[fBorders[i].p2].fY, fMiniCube[fBorders[i].p2].fZ) >= 0.000001)))
		{
			return true;
		}
		return false;
	}

	if (((NewZ(fMiniCube[fBorders[i].p1].fX, fMiniCube[fBorders[i].p1].fY, fMiniCube[fBorders[i].p1].fZ) >= 0.000001) &&
		(NewZ(fMiniCube[fBorders[i].p2].fX, fMiniCube[fBorders[i].p2].fY, fMiniCube[fBorders[i].p2].fZ) <= 0.000001)) ||
		((NewZ(fMiniCube[fBorders[i].p1].fX, fMiniCube[fBorders[i].p1].fY, fMiniCube[fBorders[i].p1].fZ) <= 0.000001) &&
		(NewZ(fMiniCube[fBorders[i].p2].fX, fMiniCube[fBorders[i].p2].fY, fMiniCube[fBorders[i].p2].fZ) >= 0.000001)))
	{
		return true;
	}
	return false;
}

int CutterObject::FindBorder()
{
	for (int i = 0; i < 12; i++) {
		fBorders[i].checked = true;
		if (IsCrossed(i)) {
			return i;
		}
	}
	return -1;
}

bool CutterObject::IsInDots(Dot d)
{
	for (int i = 0; i <= fDotCount; i++) {
		if ((d.fX == fDots[i].fX) && (d.fY == fDots[i].fY) && (d.fZ == fDots[i].fZ))
		{
			return true;
		}
	}
	return false;
}

void CutterObject::CiklNext(int gt, int rt)
{
	int rs;
	bool ok = false;

	//ищем пересечение с ребрами текущей грани...
	for (int i = 0; i < 4; i++) {
		//если ребро не проверено...
		if (!fBorders[fBoundaries[gt][i]].checked) {
			fBorders[fBoundaries[gt][i]].checked = true;
			//ищем пересечение...
			if (IsCrossed(fBoundaries[gt][i])) {
				//нашли пересечение! (новое уникальное ребро)
				fCrossedBorders[fBoundaries[gt][i]] = true;
				if (!IsInDots(FindNewDot(fBoundaries[gt][i]))) {
					fDotCount += 1;
					fDots[fDotCount] = FindNewDot(fBoundaries[gt][i]);
				}
				rs = fBoundaries[gt][i];
				ok = true;
				break;
			}
		}
	}

	if (ok) {
		if (fBorders[rs].link[0] != gt) {
			CiklNext(fBorders[rs].link[0], rs);
		} else {
			CiklNext(fBorders[rs].link[1], rs);
		}
	}
}

void CutterObject::ShiftDots()
{
	for (int i = fDotCount; i > 0; i--) {
		fDots[i] = fDots[i-1];
	}
}

void CutterObject::CiklPrev(int gt, int rt)
{
	int rs;
	bool ok = false;

	//ищем пересечение с ребрами текущей грани...
	for (int i = 0; i < 4; i++) {
		//если ребро не проверено...
		if (!fBorders[fBoundaries[gt][i]].checked) {
			fBorders[fBoundaries[gt][i]].checked = true;
			//ищем пересечение...
			if (IsCrossed(fBoundaries[gt][i])) {
				//нашли пересечение! (новое уникальное ребро)
				fCrossedBorders[fBoundaries[gt][i]] = true;
				if (!IsInDots(FindNewDot(fBoundaries[gt][i]))) {
					fDotCount += 1;
					ShiftDots();
					fDots[0] = FindNewDot(fBoundaries[gt][i]);
				}
				rs = fBoundaries[gt][i];
				ok = true;
				break;
			}
		}
	}

	if (ok) {
		if (fBorders[rs].link[0] != gt) {
			CiklPrev(fBorders[rs].link[0], rs);
		} else {
			CiklPrev(fBorders[rs].link[1], rs);
		}
	}
}

void CutterObject::DoTriang()
{
	if (fDotCount >= 2) {
		for (int i = 2; i <= fDotCount; i++) {
			fPlane->Add(fDots[0], fDots[i-1], fDots[i]);
		}
	}
}

void CutterObject::WorkWithCube(int i, int j, int k, int parameter)
{
	int rs; //стартовые ребро и грань

	SetMiniCube(i,j,k); //определяем текущий мини-куб

	switch (parameter) {
		case -1: rs = FindBorder(); break;
		default: rs = parameter; fBorders[rs].checked = true; break;
	}

	fDotCount = 0;
	fDots[fDotCount] = FindNewDot(rs);

	CiklNext(fBorders[rs].link[0], rs); //прямой цикл
	CiklPrev(fBorders[rs].link[1], rs); //обратный цикл
	DoTriang(); //триангуляция
}

void CutterObject::ResetCrossedBorders()
{
	for (int i = 0; i < 12; i++) {
		fCrossedBorders[i] = false;
	}
}

void CutterObject::StartNextLook(int ti, int tj, int tk, int num)
{
	if ((ti >= 0) && (ti < fBorderCount-1) &&
		(tj >= 0) && (tj < fBorderCount-1) &&
		(tk >= 0) && (tk < fBorderCount-1)
	) {
		if (!fCubeChecked[ti][tj][tk]) {
			fCubeChecked[ti][tj][tk] = true;
			WorkWithCube(ti,tj,tk,num);
			LookUpBorder(ti,tj,tk);
		}
	}
}

void CutterObject::LookUpBorder(int i, int j, int k)
{
	int ti, tj, tk;
	bool rz[12];

	for (int m = 0; m < 12; m++) {
		rz[m] = fCrossedBorders[m];
	}

	ResetCrossedBorders();

	for (int m = 0; m < 12; m++) {
		if (rz[m]) {
			switch (m) {
				case 0:  StartNextLook(i,j,k-1,4);  StartNextLook(i,j-1,k,2);  StartNextLook(i,j-1,k-1,6);  break;
				case 1:  StartNextLook(i+1,j,k,3);  StartNextLook(i,j,k-1,5);  StartNextLook(i+1,j,k-1,7);  break;
				case 2:  StartNextLook(i,j+1,k,0);  StartNextLook(i,j,k-1,6);  StartNextLook(i,j+1,k-1,4);  break;
				case 3:  StartNextLook(i-1,j,k,1);  StartNextLook(i,j,k-1,7);  StartNextLook(i-1,j,k-1,5);  break;
				case 4:  StartNextLook(i,j-1,k,6);  StartNextLook(i,j,k+1,0);  StartNextLook(i,j-1,k+1,2);  break;
				case 5:  StartNextLook(i+1,j,k,7);  StartNextLook(i,j,k+1,1);  StartNextLook(i+1,j,k+1,3);  break;
				case 6:  StartNextLook(i,j,k+1,2);  StartNextLook(i,j+1,k,4);  StartNextLook(i,j+1,k+1,0);  break;
				case 7:  StartNextLook(i,j,k+1,3);  StartNextLook(i-1,j,k,5);  StartNextLook(i-1,j,k+1,1);  break;
				case 8:  StartNextLook(i-1,j,k,9);  StartNextLook(i,j-1,k,11); StartNextLook(i-1,j-1,k,10); break;
				case 9:  StartNextLook(i,j-1,k,10); StartNextLook(i+1,j,k,8);  StartNextLook(i+1,j-1,k,11); break;
				case 10: StartNextLook(i+1,j,k,11); StartNextLook(i,j+1,k,9);  StartNextLook(i+1,j+1,k,8);  break;
				case 11: StartNextLook(i,j+1,k,8);  StartNextLook(i-1,j,k,10); StartNextLook(i-1,j+1,k,9);  break;
			}
		}
	}
}

void CutterObject::FindCubes()
{
	int it, jt, kt;

	for (int j = 0; j < fBorderCount; j = j + fBorderCount - 1) {
		for (int k = 0; k < fBorderCount; k = k + fBorderCount - 1) {
			for (int i = 0; i < fBorderCount - 1; i++) {
				if (i == trunc(-(zz0 + j*zz2 + k*zz3)/zz1)) {
					it = i; jt = j; kt = k;
					if (j == fBorderCount - 1) jt = j - 1;
					if (k == fBorderCount - 1) kt = k - 1;
					if (fCubeChecked[it][jt][kt]) break;
					fCubeChecked[it][jt][kt] = true;
					WorkWithCube(it,jt,kt,-1);
					LookUpBorder(it,jt,kt);
					return;
				}
			}
		}
	}

	for (int i = 0; i < fBorderCount; i = i + fBorderCount - 1) {
		for (int k = 0; k < fBorderCount; k = k + fBorderCount - 1) {
			for (int j = 0; j < fBorderCount - 1; j++) {
				if (j == trunc(-(zz0 + i*zz1 + k*zz3)/zz2)) {
					it = i; jt = j; kt = k;
					if (i == fBorderCount - 1) it = i - 1;
					if (k == fBorderCount - 1) kt = k - 1;
					if (fCubeChecked[it][jt][kt]) break;
					fCubeChecked[it][jt][kt] = true;
					WorkWithCube(it,jt,kt,-1);
					LookUpBorder(it,jt,kt);
					return;
				}
			}
		}
	}

	for (int i = 0; i < fBorderCount; i = i + fBorderCount - 1) {
		for (int j = 0; j < fBorderCount; j = j + fBorderCount - 1) {
			for (int k = 0; k < fBorderCount - 1; k++) {
				if (k == trunc(-(zz0 + i*zz1 + j*zz2)/zz3)) {
					it = i; jt = j; kt = k;
					if (i == fBorderCount - 1) it = i - 1;
					if (j == fBorderCount - 1) jt = j - 1;
					if (fCubeChecked[it][jt][kt]) break;
					fCubeChecked[it][jt][kt] = true;
					WorkWithCube(it,jt,kt,-1);
					LookUpBorder(it,jt,kt);
					return;
				}
			}
		}
	}
}

//------------------------------------------------------------------------------------*/

void CutterObject::SetRandomCube()
{
	fCube.resize(fBorderCount);
	for (int i = 0; i < fCube.size(); i++)
	{
		fCube[i].resize(fBorderCount);
		for (int j = 0; j < fCube[i].size(); j++)
		{
			fCube[i][j].resize(fBorderCount);
			for (int k = 0; k < fCube[i][j].size(); k++)
			{
				fCube[i][j][k] = (rand() % 256)-1; //0-255
			}
		}
	}
}

void CutterObject::ResetCubeChecked()
{
	fCubeChecked.resize(fBorderCount-1);
	for (int i = 0; i < fCubeChecked.size(); i++)
	{
		fCubeChecked[i].resize(fBorderCount-1);
		for (int j = 0; j < fCubeChecked.size(); j++)
		{
			fCubeChecked[i][j].resize(fBorderCount-1);
			for (int k = 0; k < fCubeChecked.size(); k++)
			{
				fCubeChecked[i][j][k] = false;
			}
		}
	}
}

void CutterObject::SetZeroPoint(int x, int y, int z)
{
	fZeroPointX = x;
	fZeroPointY = y;
	fZeroPointZ = z;
}

void CutterObject::SetNormalVector(int x, int y, int z)
{
	fNormalVectorX = x;
	fNormalVectorY = y;
	fNormalVectorZ = z;
}

CutterObject::CutterObject(int count)
{
	fBorderLength = kBorderLength;
	fBorderCount = count;

	SetMiniCubeDefaults();

	SetRandomCube();
	ResetCubeChecked();
	SetZeroPoint(0, 0, 0);
	SetNormalVector(-1, -1, 1);
	fPlane = new TriangleList();
}

CutterObject::CutterObject()
{
	fBorderLength = kBorderLength;
	fBorderCount = kBorderCount;

	SetMiniCubeDefaults();

	SetRandomCube();
	ResetCubeChecked();
	SetZeroPoint(fBorderLength/2, fBorderLength/2, fBorderLength/2);
	SetNormalVector(1, 1, 1);
	fPlane = new TriangleList();
}

CutterObject::~CutterObject()
{
	delete fPlane;
}

void CutterObject::FindPlane()
{
	FindDegrees();
	FindZ();
	FindCubes();
}

void CutterObject::FindSimplePlane()
{
}
