#include <math.h>
#include "CutterObject.h"

void CutterObject::DrawCube()
{
	glLineWidth(1);
	glColor3f(1.0, 1.0, 1.0);

	int dd = fBorderCount;

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(0,0,0), GetY(0,0,0), GetZ(0,0,0));
		glVertex3d(GetX(0,dd-1,0), GetY(0,dd-1,0), GetZ(0,dd-1,0));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(0,0,0), GetY(0,0,0), GetZ(0,0,0));
		glVertex3d(GetX(0,0,dd-1), GetY(0,0,dd-1), GetZ(0,0,dd-1));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(0,0,0), GetY(0,0,0), GetZ(0,0,0));
		glVertex3d(GetX(dd-1,0,0), GetY(dd-1,0,0), GetZ(dd-1,0,0));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(dd-1,dd-1,dd-1), GetY(dd-1,dd-1,dd-1), GetZ(dd-1,dd-1,dd-1));
		glVertex3d(GetX(dd-1,0,dd-1), GetY(dd-1,0,dd-1), GetZ(dd-1,0,dd-1));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(dd-1,dd-1,dd-1), GetY(dd-1,dd-1,dd-1), GetZ(dd-1,dd-1,dd-1));
		glVertex3d(GetX(dd-1,dd-1,0), GetY(dd-1,dd-1,0), GetZ(dd-1,dd-1,0));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(dd-1,dd-1,dd-1), GetY(dd-1,dd-1,dd-1), GetZ(dd-1,dd-1,dd-1));
		glVertex3d(GetX(0,dd-1,dd-1), GetY(0,dd-1,dd-1), GetZ(0,dd-1,dd-1));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(0,0,dd-1), GetY(0,0,dd-1), GetZ(0,0,dd-1));
		glVertex3d(GetX(0,dd-1,dd-1), GetY(0,dd-1,dd-1), GetZ(0,dd-1,dd-1));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(0,0,dd-1), GetY(0,0,dd-1), GetZ(0,0,dd-1));
		glVertex3d(GetX(dd-1,0,dd-1), GetY(dd-1,0,dd-1), GetZ(dd-1,0,dd-1));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(0,dd-1,0), GetY(0,dd-1,0), GetZ(0,dd-1,0));
		glVertex3d(GetX(0,dd-1,dd-1), GetY(0,dd-1,dd-1), GetZ(0,dd-1,dd-1));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(0,dd-1,0), GetY(0,dd-1,0), GetZ(0,dd-1,0));
		glVertex3d(GetX(dd-1,dd-1,0), GetY(dd-1,dd-1,0), GetZ(dd-1,dd-1,0));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(dd-1,0,0), GetY(dd-1,0,0), GetZ(dd-1,0,0));
		glVertex3d(GetX(dd-1,0,dd-1), GetY(dd-1,0,dd-1), GetZ(dd-1,0,dd-1));
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3d(GetX(dd-1,0,0), GetY(dd-1,0,0), GetZ(dd-1,0,0));
		glVertex3d(GetX(dd-1,dd-1,0), GetY(dd-1,dd-1,0), GetZ(dd-1,dd-1,0));
	glEnd();
}

void CutterObject::DrawVectors()
{
	glLineWidth(2);

	int len = sqrt(
		pow(fNormalVectorX, 2) +
		pow(fNormalVectorY, 2) +
		pow(fNormalVectorZ, 2)
	);

	//vector N
	glColor3f(0.0, 1.0, 0.0);
	glBegin(GL_LINE_STRIP);
		glVertex3f(
			0.0 + fZeroPointX,
			0.0 + fZeroPointY,
			0.0 + fZeroPointZ
		);
		glVertex3f(
			fNormalVectorX*50/len + fZeroPointX,
			fNormalVectorY*50/len + fZeroPointY,
			fNormalVectorZ*50/len + fZeroPointZ
		);
	glEnd();

	//vector oX
	glColor3f(1.0, 0.0, 0.0);
	glBegin(GL_LINE_STRIP);
		glVertex3f(0.0 - 10, 0.0 - 10, 0.0 - 10);
		glVertex3f(1*300 - 10, 0*50 - 10, 0*50 - 10);
	glEnd();
	glBegin(GL_LINE_STRIP);
		glVertex3f(1*300 - 10, 0*50 - 10, 0*50 - 10);
		glVertex3f(1*300 - 10 - 20, 0*50 - 10 + 10, 0*50 - 10);
	glEnd();
	glBegin(GL_LINE_STRIP);
		glVertex3f(1*300 - 10, 0*50 - 10, 0*50 - 10);
		glVertex3f(1*300 - 10 - 20, 0*50 - 10 - 10, 0*50 - 10);
	glEnd();

	//vector oY
	glColor3f(0.0, 0.0, 1.0);
	glBegin(GL_LINE_STRIP);
		glVertex3f(0.0 - 10, 0.0 - 10, 0.0 - 10);
		glVertex3f(0*50 - 10, 1*300 - 10, 0*50 - 10);
	glEnd();
	glBegin(GL_LINE_STRIP);
		glVertex3f(0*50 - 10, 1*300 - 10, 0*50 - 10);
		glVertex3f(0*50 - 10 + 10, 1*300 - 10 - 20, 0*50 - 10);
	glEnd();
	glBegin(GL_LINE_STRIP);
		glVertex3f(0*50 - 10, 1*300 - 10, 0*50 - 10);
		glVertex3f(0*50 - 10 - 10, 1*300 - 10 - 20, 0*50 - 10);
	glEnd();

	//vector oZ
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_LINE_STRIP);
		glVertex3f(0.0 - 10, 0.0 - 10, 0.0 - 10);
		glVertex3f(0*50 - 10, 0*50 - 10, 1*300 - 10);
	glEnd();
	glBegin(GL_LINE_STRIP);
		glVertex3f(0*50 - 10, 0*50 - 10, 1*300 - 10);
		glVertex3f(0*50 - 10 + 7, 0*50 - 10 - 7, 1*300 - 10 - 20);
	glEnd();
	glBegin(GL_LINE_STRIP);
		glVertex3f(0*50 - 10, 0*50 - 10, 1*300 - 10);
		glVertex3f(0*50 - 10 - 7, 0*50 - 10 + 7, 1*300 - 10 - 20);
	glEnd();
}

void CutterObject::Draw(bool doDrawPlane, bool doDrawSimplePlane
	, bool doDrawCube, bool doDrawVectors)
{
	if (doDrawPlane) {
		fPlane->Draw();
	}
	if (doDrawSimplePlane) {
	}
	if (doDrawCube) {
		DrawCube();
	}
	if (doDrawVectors) {
		DrawVectors();
	}
}
