#include "CutterPrimitives.h"

void Triangle::Draw()
{
	glBegin(GL_TRIANGLES);
		for (int i = 0; i < 3; i++) {
			glColor3ub(fPoints[i].fTemperature, 0, 255-fPoints[i].fTemperature);
			glVertex3d(fPoints[i].fX, fPoints[i].fY, fPoints[i].fZ);
		}
	glEnd();
}

TriangleList::~TriangleList()
{
	Triangle *cur, *temp;

	cur = fHead;
	while (cur != NULL) {
		temp = cur;
		cur = cur->fNext;
		delete temp;
	}
}

void TriangleList::Add(Dot p1, Dot p2, Dot p3)
{
	Triangle *temp;

	temp = new Triangle(p1,p2,p3);

	if (fHead == NULL) {
		fHead = fTail = temp;
	} else {
		fTail->fNext = temp;
		fTail = temp;
	}
}

void TriangleList::Draw()
{
	Triangle *cur = fHead;
	while (cur != NULL) {
		cur->Draw();
		cur = cur->fNext;
	}
}
