#ifndef _CUTTER_PRIMITIVES_H
#define _CUTTER_PRIMITIVES_H

#include <GL/glut.h>
#include <stdlib.h>

class Dot {
	public:
		double fX, fY, fZ;
		GLubyte fTemperature;

		Dot()
			: fX(0), fY(0), fZ(0), fTemperature(0) {};
		Dot(double x, double y, double z, GLubyte t)
			: fX(x), fY(y), fZ(z), fTemperature(t) {};

		void Draw();
};

class Triangle {
	public:
		Dot fPoints[3];
		Triangle *fNext;

		Triangle()
			: fNext(NULL) {};
		Triangle(Dot p1, Dot p2, Dot p3)
			: fNext(NULL) {
			fPoints[0] = p1;
			fPoints[1] = p2;
			fPoints[2] = p3;
		};

		void Draw();
};

class TriangleList {
	public:
 		Triangle *fHead, *fTail;

		TriangleList()
			: fHead(NULL), fTail(NULL) {};
		~TriangleList();

		void Add(Dot p1, Dot p2, Dot p3);
		void Draw();
};

#endif
